<?php

if (!defined('_PS_VERSION_'))
    exit;

class RutcomNadajesz extends Module
{

    public $url;

    public function __construct()
    {
        $this->name = 'rutcomnadajesz';
        $this->tab = 'front_office_features';
        $this->version = '1.1';
        $this->author = 'Rutcom';
        $this->need_instance = 0;

        $this->bootstrap = true;
        parent::__construct();

        $this->displayName = $this->l('Nadajesz.pl');
        $this->description = $this->l('Integracja z serwisem nadajesz.pl');

        $this->url = '?controller=adminmodules&configure=' . $this->name . '&token=' . Tools::getValue('token') . '&tab_module=' . $this->tab . '&module_name=' . $this->name;
    }

    public function install()
    {
        if (Shop::isFeatureActive())
            Shop::setContext(Shop::CONTEXT_ALL);

        if (parent::install() == false || $this->registerHook('displayAdminOrderLeft') == false || $this->registerHook('actionCarrierUpdate') == false)
            return false;

        $shops = Shop::getShops(true, null, true);
        $languages = Language::getLanguages(false);

        $res = Db::getInstance()->execute(
                'CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'rutcom_nadajesz` (
			`id` int(10) unsigned NOT NULL auto_increment,
			`email` TEXT NOT NULL ,
			`apikey` TEXT NOT NULL,
                        `sender_name` TEXT NOT NULL,
                        `sender_lastname` TEXT NOT NULL,
                        `sender_company` TEXT NOT NULL,
                        `sender_street` TEXT NOT NULL,
                        `sender_post_code` TEXT NOT NULL,
                        `sender_city` TEXT NOT NULL,
                        `sender_phone` TEXT NOT NULL,
			PRIMARY KEY (`id`))
			ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8'
        );

        $res2 = Db::getInstance()->execute(
                'CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'rutcom_nadajesz_zlecenia` (
			`id` int(10) unsigned NOT NULL auto_increment,
                        `id_order` int(10) unsigned NOT NULL ,
			`id_nadajesz` int(10) unsigned NOT NULL ,
                        `info` TEXT NULL,
                        `created_at` DATETIME,
			PRIMARY KEY (`id`))
			ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8'
        );

        $res3 = Db::getInstance()->execute(
                'CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'rutcom_nadajesz_carriers` (
			`id` int(10) unsigned NOT NULL auto_increment,
                        `id_carrier` int(10) unsigned NOT NULL,
                        `pobranie` int(10) unsigned NOT NULL DEFAULT 0,
			PRIMARY KEY (`id`))
			ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8'
        );

        $sql = "INSERT INTO " . _DB_PREFIX_ . "rutcom_nadajesz (id) VALUES (1)";
        $results = Db::getInstance()->executeS($sql);
    }

    public function uninstall()
    {
        $res = Db::getInstance()->execute('DROP TABLE IF EXISTS `' . _DB_PREFIX_ . 'rutcom_nadajesz`');
        $res2 = Db::getInstance()->execute('DROP TABLE IF EXISTS `' . _DB_PREFIX_ . 'rutcom_nadajesz_zlecenia`');
        $res3 = Db::getInstance()->execute('DROP TABLE IF EXISTS `' . _DB_PREFIX_ . 'rutcom_nadajesz_carriers`');

        if ($res == 0 || !parent::uninstall())
            return false;
        return true;
    }

    public function hookActionCarrierUpdate($params)
    {
        $sql = "SELECT * FROM " . _DB_PREFIX_ . "rutcom_nadajesz_carriers";
        $nadajesz_config = Db::getInstance()->executeS($sql);
        foreach ($nadajesz_config as $key => $item)
        {
            $nadajesz_carrier_check = new Carrier($item['id_carrier']);
            $sql_max = "SELECT MAX(id_carrier) as id_max FROM " . _DB_PREFIX_ . "carrier";
            $max_result = Db::getInstance()->getRow($sql_max);
            if ($nadajesz_carrier_check->id_reference == $params['carrier']->id_reference)
            {
                $new_max_id = (int) intval($max_result['id_max']);
                $sql = 'UPDATE  ' . _DB_PREFIX_ . "rutcom_nadajesz_carriers SET id_carrier = " . $new_max_id . " WHERE id_carrier = " . $item['id_carrier'];
                $results = Db::getInstance()->getRow($sql);
            }
        }
    }

    public function hookDisplayAdminOrderLeft($params)
    {
        $sql = "SELECT * FROM " . _DB_PREFIX_ . "rutcom_nadajesz WHERE id = 1";
        $nadajesz_config = Db::getInstance()->getRow($sql);
        $nadajesz_zlecenie = NULL;
        $sql = "SELECT * FROM " . _DB_PREFIX_ . "rutcom_nadajesz_zlecenia WHERE id_order = " . $params['id_order'];
        $nadajesz_zlecenie = Db::getInstance()->getRow($sql);
        if ($_POST['submit_sendorder'])
        {

            if (isset($nadajesz_zlecenie))
            {
                $created_at = date('Y-m-d H:i:s');
                $nadajesz_data = json_decode($this->sendOrderToNadajesz($params));
                if (isset($nadajesz_data))
                {
                    if ($nadajesz_data->status == "ok")
                    {
                        $sql = "INSERT INTO " . _DB_PREFIX_ . "rutcom_nadajesz_zlecenia (id_order, id_nadajesz, info, created_at) VALUES ("
                                . $params['id_order']
                                . ", " . $nadajesz_data->order_number
                                . ", '<strong>Numer zlecenia: </strong>" . $nadajesz_data->order_number . "<br><strong>Numer śledzenia przesyłki: </strong>" . $nadajesz_data->tracking . " <br><strong>URL śledzenia: </strong>" . $nadajesz_data->url_tracking . "'"
                                . ",  '" . $created_at . "')";
                        $results = Db::getInstance()->executeS($sql);
                    }
                    else
                    {
                        
                    }
                }
                else
                {
                    
                }
            }
            Tools::redirectAdmin('index.php?controller=AdminOrders&id_order=' . $params['id_order'] . '&vieworder&token=' . Tools::getAdminTokenLite('AdminOrders'));
        }

        $carriers_selected_sql = "SELECT id_carrier FROM " . _DB_PREFIX_ . "rutcom_nadajesz_carriers";
        $carriers_selected = Db::getInstance()->executeS($carriers_selected_sql);
        $carriers_selected_arr = array();
        foreach ($carriers_selected as $key => $item)
        {
            $carrier_reference_sql = "SELECT id_reference FROM " . _DB_PREFIX_ . "carrier WHERE id_carrier = ". (int) $item['id_carrier'];
            $carrier_reference_result = Db::getInstance()->getRow($carrier_reference_sql);
            $carriers_by_reference_sql = "SELECT * FROM " . _DB_PREFIX_ . "carrier WHERE id_reference = ". (int) $carrier_reference_result['id_reference'];
            $carriers_by_reference = Db::getInstance()->executeS($carriers_by_reference_sql);
            foreach ($carriers_by_reference as $key_ref => $item_ref)
            {
                $carriers_selected_arr[] = $item_ref['id_carrier'];
            }
        }

        if (in_array($params['cart']->id_carrier, $carriers_selected_arr))
        {
            $this->smarty->assign(array(
                'this_url' => $this->url,
                'nadajesz_config' => $nadajesz_config,
                'nadajesz_zlecenie' => $nadajesz_zlecenie,
                'mainurl' => _PS_BASE_URL_ . __PS_BASE_URI__,
            ));
            return $this->display(__FILE__, 'views/admin/order.tpl');
        }
    }

    private function sendOrderToNadajesz($params)
    {
        $order = new Order($params['id_order']);
        $deliveryAddress = new Address($order->id_address_delivery);
        $customer = new Customer($deliveryAddress->id_customer);
        $sql = "SELECT * FROM " . _DB_PREFIX_ . "rutcom_nadajesz WHERE id = 1";
        $sql_carrier_data = "SELECT * FROM " . _DB_PREFIX_ . "rutcom_nadajesz_carriers WHERE id_carrier = " . $order->id_carrier;
        $sender = Db::getInstance()->getRow($sql);
        $carrier_data = Db::getInstance()->getRow($sql_carrier_data);
        $phones = array();
        $addresses = array();
        if (isset($deliveryAddress->phone))
        {
            if ($deliveryAddress->phone != '')
                array_push($phones, $deliveryAddress->phone);
        }
        if (isset($deliveryAddress->phone_mobile))
        {
            if ($deliveryAddress->phone_mobile != '')
                array_push($phones, $deliveryAddress->phone_mobile);
        }

        if (isset($deliveryAddress->address1))
        {
            if ($deliveryAddress->address1 != '')
                array_push($addresses, $deliveryAddress->address1);
        }
        if (isset($deliveryAddress->address2))
        {
            if ($deliveryAddress->address2 != '')
                array_push($addresses, $deliveryAddress->address2);
        }

        $url = 'https://nadajesz.pl/api/v1/order';
        $post_options = array(
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_HEADER => false,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_ENCODING => "",
            CURLOPT_USERAGENT => "test",
            CURLOPT_AUTOREFERER => true,
            CURLOPT_CONNECTTIMEOUT => 120,
            CURLOPT_TIMEOUT => 120,
            CURLOPT_POST => 1,
            CURLOPT_POSTFIELDS => "email=" . $sender['email']
            . "&token_api=" . $sender['apikey']
            . "&sender_email=" . $sender['email']
            . "&sender_name=" . $sender['sender_name']
            . "&sender_lastname=" . $sender['sender_lastname']
            . "&sender_company=" . $sender['sender_company']
            . "&sender_street=" . $sender['sender_street']
            . "&sender_post_code=" . $sender['sender_post_code']
            . "&sender_city=" . $sender['sender_city']
            . "&sender_phone=" . $sender['sender_phone']
            . "&customer_email=" . $customer->email
            . "&customer_name=" . $deliveryAddress->firstname
            . "&customer_company=" . $deliveryAddress->company
            . "&customer_lastname=" . $deliveryAddress->lastname
            . "&customer_street=" . implode(', ', $addresses)
            . "&customer_post_code=" . $deliveryAddress->postcode
            . "&customer_city=" . $deliveryAddress->city
            . "&customer_phone=" . implode(' / ', $phones)
            . "&pickup_day=" . date('Y-m-d')
            . "&delivery_day=" . date('Y-m-d')
            . "&comments=" . $order->getFirstMessage()
        );
        if ($carrier_data['pobranie'] == 1)
        {
            $post_options[CURLOPT_POSTFIELDS] .= '&cash_on_delivery=' . round($order->total_paid, 2);
        }
        $ch = curl_init($url);
        curl_setopt_array($ch, $post_options);
        $content = curl_exec($ch);
        curl_close($ch);
        return $content;
    }

    private function update()
    {
        $sql = 'UPDATE  ' . _DB_PREFIX_ . "rutcom_nadajesz SET "
                . "email='" . $_POST['email']
                . "', apikey = '" . $_POST['apikey']
                . "', sender_name = '" . $_POST['sender_name']
                . "', sender_lastname = '" . $_POST['sender_lastname']
                . "', sender_company = '" . $_POST['sender_company']
                . "', sender_street = '" . $_POST['sender_street']
                . "', sender_post_code = '" . $_POST['sender_post_code']
                . "', sender_city = '" . $_POST['sender_city']
                . "', sender_phone = '" . $_POST['sender_phone']
                . "' WHERE id = 1";

        $results = Db::getInstance()->execute($sql);
        $truncate_carriers = 'TRUNCATE TABLE ' . _DB_PREFIX_ . 'rutcom_nadajesz_carriers';
        Db::getInstance()->execute($truncate_carriers);
        $carriers = $_POST['carrier_checkbox'];
        $results = Db::getInstance()->execute($truncate_carriers);
        foreach ($carriers as $key => $carrier)
        {
            $pobranie = 0;
            if (isset($_POST['carrier_pobranie_' . $carrier]))
            {
                $pobranie = 1;
            }
            $insertCarrierSql = "INSERT INTO " . _DB_PREFIX_ . "rutcom_nadajesz_carriers (id_carrier, pobranie) VALUES (" . $carrier . ", " . $pobranie . ")";
            Db::getInstance()->execute($insertCarrierSql);
        }
    }

    public function getContent()
    {
        if ($_POST['submitUpdate'])
        {
            $this->update();
        }
        $sql = "SELECT * FROM " . _DB_PREFIX_ . "rutcom_nadajesz WHERE id = 1";
        $nadajesz_config = Db::getInstance()->getRow($sql);
        $values = array();
        $values['email'] = $nadajesz_config['email'];
        $values['apikey'] = $nadajesz_config['apikey'];
        $values['sender_name'] = $nadajesz_config['sender_name'];
        $values['sender_lastname'] = $nadajesz_config['sender_lastname'];
        $values['sender_company'] = $nadajesz_config['sender_company'];
        $values['sender_street'] = $nadajesz_config['sender_street'];
        $values['sender_post_code'] = $nadajesz_config['sender_post_code'];
        $values['sender_city'] = $nadajesz_config['sender_city'];
        $values['sender_phone'] = $nadajesz_config['sender_phone'];
        $values['carrier'] = $nadajesz_config['carrier'];

        $carriers_list = Carrier::getCarriers();

        $carriers_selected_sql = "SELECT * FROM " . _DB_PREFIX_ . "rutcom_nadajesz_carriers";
        $carriers_selected = Db::getInstance()->executeS($carriers_selected_sql);
        $carriers_selected_arr = array();
        $carriers_pobranie_arr = array();
        foreach ($carriers_selected as $key => $item)
        {
            $carriers_selected_arr[] = $item['id_carrier'];
            if ($item['pobranie'] == 1)
            {
                $carriers_pobranie_arr[] = $item['id_carrier'];
            }
        }

        $this->smarty->assign(array(
            'mainurl' => _PS_BASE_URL_ . __PS_BASE_URI__,
            'this_url' => $this->url,
            'carriers_list' => $carriers_list,
            'carriers_selected_arr' => $carriers_selected_arr,
            'carriers_pobranie_arr' => $carriers_pobranie_arr,
            'values' => $values,
            'this_url' => '?controller=adminmodules&configure=' . $this->name . '&token=' . Tools::getValue('token') . '&tab_module=' . $this->tab . '&module_name=' . $this->name
        ));

        return $this->display(__FILE__, 'views/admin/home.tpl');
    }

}
